package dao.entities;

import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

import javax.persistence.TypedQuery;

import org.hibernate.query.Query;

import dao.JpaDao;
import entities.Organisation;
import entities.responses.IDLabelPair;

public class OrganisationDaoImpl extends JpaDao<Organisation, UUID> implements OrganisationDao {

	public Organisation loadDetails(Organisation t) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<UUID> listAllIDs() {
		String queryString = "SELECT organisation.id FROM Organisation organisation";
		TypedQuery<UUID> typedQuery = entityManager.createQuery(queryString, UUID.class);
		return typedQuery.getResultList();
	}
	
	@Override
	public List<IDLabelPair> listAllIDsLabels() {
		String queryString = "SELECT organisation.id, organisation.label FROM Organisation organisation";
		Query query = (Query) entityManager.createQuery(queryString);
		List<Object[]> rows = query.list();
		return rows.stream().map(row -> {
			return new IDLabelPair(row[0].toString(), row[1].toString());
		})
		.collect(Collectors.toList());
	}
	
	
	
}
