import { NgModule }             from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

import { DatasetsComponent }    from './dataset.component';
//import { ProjectDetailComponent }    from './project.detail';
import { DynamicFormComponent } from '../form/dynamic-form.component';
import { AuthGuard } from '../guards/auth.guard';

const datasetsRoutes: Routes = [
  { path: 'dataset', component: DatasetsComponent },
  { path: 'dynamic-form/:id', component: DynamicFormComponent, canActivate: [AuthGuard] }
];

@NgModule({
  imports: [
    RouterModule.forChild(datasetsRoutes)
  ],
  exports: [
    RouterModule
  ]
})
export class DatasetRoutingModule { }