import { NgModule }             from '@angular/core';
import { RouterModule, Routes } from '@angular/router';

import { ProjectsComponent }    from './projects.component';
import { ProjectDetailComponent }    from './project.detail';
import { DynamicFormComponent } from '../form/dynamic-form.component';
import { AuthGuard } from '../guards/auth.guard';

const projectsRoutes: Routes = [
 // { path: 'tabs/projects', component: ProjectsComponent }, // canActivate: [AuthGuard]
  { path: 'dynamic-form/:id', component: DynamicFormComponent, canActivate: [AuthGuard] }
];

@NgModule({
  imports: [
    RouterModule.forChild(projectsRoutes)
  ],
  exports: [
    RouterModule
  ]
})
export class ProjectRoutingModule { }