import {Injectable} from '@angular/core';
import {Observable} from 'rxjs/Observable';
import {HttpEvent, HttpInterceptor, HttpHandler, HttpRequest, HttpResponse, HttpErrorResponse} from '@angular/common/http';
import { TokenService, TokenProvider } from './login/token.service';
import {Router} from '@angular/router';

@Injectable()
export class GlobalInterceptor implements HttpInterceptor {
  
    constructor(public tokenService: TokenService, private router : Router) {}
  
    intercept(req: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>> {

      return next.handle(req).do((event: HttpEvent<any>) => {
        /*
        if (event instanceof HttpResponse) {
          console.log("response ok"); 
        }
        */
      }, (err: any) => {
        if (err instanceof HttpErrorResponse) {
          if (err.status === 401) {
            console.log("Received an unauthorized... redirecting to login page");
            this.tokenService.logout();
            this.router.navigate(['/login'], { queryParams: { /*returnUrl: this.state.url*/ }});
          }
        }
      });


    //return next.handle(req);
  }
}